import { __awaiter, __generator, __extends } from 'tslib';
import { Injectable, Inject, ɵɵdefineInjectable, ɵɵinject, Directive, ElementRef, ViewContainerRef, Input, Component, ComponentFactoryResolver, ViewChildren, NgModule } from '@angular/core';
import { HttpClient, HttpClientModule } from '@angular/common/http';
import { map } from 'rxjs/operators';
import { CommonModule } from '@angular/common';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @return {?}
 */
function _window() {
    return window;
}
var WindowRef = /** @class */ (function () {
    function WindowRef() {
    }
    Object.defineProperty(WindowRef.prototype, "nativeWindow", {
        //Return the native Javascript window object
        get: 
        //Return the native Javascript window object
        /**
         * @return {?}
         */
        function () {
            return _window();
        },
        enumerable: true,
        configurable: true
    });
    WindowRef.decorators = [
        { type: Injectable }
    ];
    return WindowRef;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var MagnoliaContextService = /** @class */ (function () {
    /**
     * Constructor
     */
    function MagnoliaContextService(winRef, http, environment) {
        this.winRef = winRef;
        this.http = http;
        this.environment = environment;
        this.nativeWindow = winRef.nativeWindow;
        this.singlePageConfig = this.nativeWindow.singlePageConfig;
        this.fragmentURL = "/";
        if (this.singlePageConfig == null) {
            this.singlePageConfig = {};
        }
        else {
            this.contentNode = Promise.resolve(this.singlePageConfig.content);
        }
    }
    /**
     * Set the fragment URL.
     *
     * @param fragement URL
     */
    /**
     * Set the fragment URL.
     *
     * @param {?} fragment
     * @return {?}
     */
    MagnoliaContextService.prototype.setFragmentURL = /**
     * Set the fragment URL.
     *
     * @param {?} fragment
     * @return {?}
     */
    function (fragment) {
        //If production mode, then gather content through a REST call
        if (!this.environment.mgnEditMode) {
            this.fragmentURL = fragment;
            this.contentNode = this.retrievePageContent();
        }
    };
    /**
     * Return whether the page is in edition mode
     *
     * @return Whether the page is in edition mode
     */
    /**
     * Return whether the page is in edition mode
     *
     * @return {?} Whether the page is in edition mode
     */
    MagnoliaContextService.prototype.isEditionMode = /**
     * Return whether the page is in edition mode
     *
     * @return {?} Whether the page is in edition mode
     */
    function () {
        return this.environment.mgnEditMode;
    };
    /**
     * Returns the current Magnolia JCR node path.
     */
    /**
     * Returns the current Magnolia JCR node path.
     * @return {?}
     */
    MagnoliaContextService.prototype.getCurrentNode = /**
     * Returns the current Magnolia JCR node path.
     * @return {?}
     */
    function () {
        return __awaiter(this, void 0, void 0, function () {
            var content;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.contentNode];
                    case 1:
                        content = _a.sent();
                        return [2 /*return*/, content["@path"]];
                }
            });
        });
    };
    /**
     * Return the the defined area in the Magnolia context
     *
     * @param areaName The name of the area
     */
    /**
     * Return the the defined area in the Magnolia context
     *
     * @param {?} areaName The name of the area
     * @return {?}
     */
    MagnoliaContextService.prototype.getAreaContent = /**
     * Return the the defined area in the Magnolia context
     *
     * @param {?} areaName The name of the area
     * @return {?}
     */
    function (areaName) {
        return __awaiter(this, void 0, void 0, function () {
            var content;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.contentNode];
                    case 1:
                        content = _a.sent();
                        return [2 /*return*/, content[areaName]];
                }
            });
        });
    };
    /**
     * Return the area's defined components
     *
     * @param areaName The name of the area
     */
    /**
     * Return the area's defined components
     *
     * @param {?} areaName The name of the area
     * @return {?}
     */
    MagnoliaContextService.prototype.getAreaComponents = /**
     * Return the area's defined components
     *
     * @param {?} areaName The name of the area
     * @return {?}
     */
    function (areaName) {
        return __awaiter(this, void 0, void 0, function () {
            var results, content, areaContent, components;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        results = new Array();
                        return [4 /*yield*/, this.contentNode];
                    case 1:
                        content = _a.sent();
                        ;
                        //Gets the area content
                        areaContent = content[areaName];
                        if (areaContent != null) {
                            components = areaContent["@nodes"];
                            components.map((/**
                             * @param {?} nodeName
                             * @return {?}
                             */
                            function (nodeName) {
                                /** @type {?} */
                                var value = areaContent[nodeName];
                                if (typeof (value) === "object" && value["@nodeType"] === "mgnl:component") {
                                    results.push(value);
                                }
                            }));
                        }
                        return [2 /*return*/, results];
                }
            });
        });
    };
    /**
     * Return the component mapping
     *
     * @param nodePath The component mapping
     */
    /**
     * Return the component mapping
     *
     * @param {?} templateId
     * @return {?}
     */
    MagnoliaContextService.prototype.getComponentMapping = /**
     * Return the component mapping
     *
     * @param {?} templateId
     * @return {?}
     */
    function (templateId) {
        if (this.singlePageConfig.componentMappings !== null) {
            return this.singlePageConfig.componentMappings[templateId];
        }
        else {
            return null;
        }
    };
    /**
     * Return the HTML comment
     *
     * @param nodePath The node path
     */
    /**
     * Return the HTML comment
     *
     * @param {?} nodePath The node path
     * @return {?}
     */
    MagnoliaContextService.prototype.getHtmlComment = /**
     * Return the HTML comment
     *
     * @param {?} nodePath The node path
     * @return {?}
     */
    function (nodePath) {
        if (this.singlePageConfig.htmlComments !== null) {
            return this.singlePageConfig.htmlComments[nodePath];
        }
        else {
            return null;
        }
    };
    /**
     * Return the page content JSON
     */
    /**
     * Return the page content JSON
     * @private
     * @return {?}
     */
    MagnoliaContextService.prototype.retrievePageContent = /**
     * Return the page content JSON
     * @private
     * @return {?}
     */
    function () {
        return __awaiter(this, void 0, void 0, function () {
            var _a;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        _a = this.singlePageConfig;
                        return [4 /*yield*/, this.retrieveComponentMappings()];
                    case 1:
                        _a.componentMappings = _b.sent();
                        return [2 /*return*/, this.http.get(this.environment.restUrl + this.fragmentURL).pipe(map((/**
                             * @param {?} response
                             * @return {?}
                             */
                            function (response) {
                                //console.log("retrievePageContent with " + this.fragmentURL + " value " + JSON.stringify(response,
                                // null, 2));
                                return response;
                            }))).toPromise()];
                }
            });
        });
    };
    /**
     * Return the fragment content JSON
     */
    /**
     * Return the fragment content JSON
     * @private
     * @return {?}
     */
    MagnoliaContextService.prototype.retrieveComponentMappings = /**
     * Return the fragment content JSON
     * @private
     * @return {?}
     */
    function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.http.get(this.environment.configRestUrl + this.fragmentURL).pipe(map((/**
                     * @param {?} response
                     * @return {?}
                     */
                    function (response) {
                        //console.log("retrieveComponentMappings with " + this.fragmentURL + " value " +
                        // JSON.stringify(response, null, 2));
                        return response;
                    }))).toPromise()];
            });
        });
    };
    MagnoliaContextService.decorators = [
        { type: Injectable, args: [{
                    providedIn: 'root'
                },] }
    ];
    /** @nocollapse */
    MagnoliaContextService.ctorParameters = function () { return [
        { type: WindowRef },
        { type: HttpClient },
        { type: undefined, decorators: [{ type: Inject, args: ['env',] }] }
    ]; };
    /** @nocollapse */ MagnoliaContextService.ngInjectableDef = ɵɵdefineInjectable({ factory: function MagnoliaContextService_Factory() { return new MagnoliaContextService(ɵɵinject(WindowRef), ɵɵinject(HttpClient), ɵɵinject("env")); }, token: MagnoliaContextService, providedIn: "root" });
    return MagnoliaContextService;
}());
if (false) {
    /**
     * Native window object.
     * @type {?}
     */
    MagnoliaContextService.prototype.nativeWindow;
    /**
     * Single page config.
     * @type {?}
     */
    MagnoliaContextService.prototype.singlePageConfig;
    /**
     * Fragment URL.
     * @type {?}
     */
    MagnoliaContextService.prototype.fragmentURL;
    /**
     * Content node.
     * @type {?}
     * @private
     */
    MagnoliaContextService.prototype.contentNode;
    /**
     * @type {?}
     * @private
     */
    MagnoliaContextService.prototype.winRef;
    /**
     * @type {?}
     * @private
     */
    MagnoliaContextService.prototype.http;
    /**
     * @type {?}
     * @private
     */
    MagnoliaContextService.prototype.environment;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @record
 */
function MagnoliaComponent() { }
if (false) {
    /**
     * Component config.
     * @type {?}
     */
    MagnoliaComponent.prototype.component;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var ComponentDirective = /** @class */ (function () {
    /**
     * Constructor.
     */
    function ComponentDirective(el, mgnCtxService, viewContainerRef) {
        this.el = el;
        this.mgnCtxService = mgnCtxService;
        this.viewContainerRef = viewContainerRef;
        this.nativeElement = el.nativeElement;
    }
    /**
     * On init
     */
    /**
     * On init
     * @return {?}
     */
    ComponentDirective.prototype.ngOnInit = /**
     * On init
     * @return {?}
     */
    function () {
        if (this.mgnCtxService.isEditionMode()) {
            //Get the HTML comment
            /** @type {?} */
            var htmlComment = this.mgnCtxService.getHtmlComment(this.component['@path']);
            //Get parent
            /** @type {?} */
            var parentDiv = this.nativeElement.parentNode;
            //Create comment before
            /** @type {?} */
            var commentBefore = document.createComment(htmlComment.start);
            parentDiv.appendChild(commentBefore);
            //Create comment after
            /** @type {?} */
            var commentAfter = document.createComment(htmlComment.end);
            parentDiv.appendChild(commentAfter);
            //Insert comment before
            parentDiv.insertBefore(commentBefore, this.nativeElement);
            //Insert comment after
            parentDiv.insertBefore(commentAfter, this.nativeElement.nextSibling);
        }
    };
    ComponentDirective.decorators = [
        { type: Directive, args: [{
                    selector: '[cmsComponent]'
                },] }
    ];
    /** @nocollapse */
    ComponentDirective.ctorParameters = function () { return [
        { type: ElementRef },
        { type: MagnoliaContextService },
        { type: ViewContainerRef }
    ]; };
    ComponentDirective.propDecorators = {
        component: [{ type: Input }]
    };
    return ComponentDirective;
}());
if (false) {
    /**
     * Native element.
     * @type {?}
     */
    ComponentDirective.prototype.nativeElement;
    /**
     * Component config.
     * @type {?}
     */
    ComponentDirective.prototype.component;
    /**
     * @type {?}
     * @private
     */
    ComponentDirective.prototype.el;
    /**
     * @type {?}
     * @private
     */
    ComponentDirective.prototype.mgnCtxService;
    /** @type {?} */
    ComponentDirective.prototype.viewContainerRef;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var AbstractArea = /** @class */ (function () {
    /**
     * Constructor
     */
    function AbstractArea(elementRef, mgnCtxService, resolver) {
        this.elementRef = elementRef;
        this.mgnCtxService = mgnCtxService;
        this.resolver = resolver;
    }
    /**
     * On init
     */
    /**
     * On init
     * @return {?}
     */
    AbstractArea.prototype.ngOnInit = /**
     * On init
     * @return {?}
     */
    function () {
        var _this = this;
        this.mgnCtxService.getAreaComponents(this.cmsArea).then((/**
         * @param {?} data
         * @return {?}
         */
        function (data) {
            _this.components = data;
        }));
    };
    /**
     * Loads component after init
     */
    /**
     * Loads component after init
     * @return {?}
     */
    AbstractArea.prototype.ngAfterViewInit = /**
     * Loads component after init
     * @return {?}
     */
    function () {
        var _this = this;
        /** @type {?} */
        var current = this;
        //Attempt to load directly after init
        this.loadComponents(current);
        //Otherwise, observe the changes on the list of templates
        this.templates.changes.subscribe((/**
         * @return {?}
         */
        function () { return _this.loadComponents(current); }));
    };
    /**
     * Loads the components dynamically.
     *
     * @param current The current area
     */
    /**
     * Loads the components dynamically.
     *
     * @param {?} current The current area
     * @return {?}
     */
    AbstractArea.prototype.loadComponents = /**
     * Loads the components dynamically.
     *
     * @param {?} current The current area
     * @return {?}
     */
    function (current) {
        current.templates.forEach((/**
         * @param {?} item
         * @param {?} index
         * @param {?} array
         * @return {?}
         */
        function (item, index, array) {
            //Gets the component
            /** @type {?} */
            var component = item.component;
            // Gets the component class
            /** @type {?} */
            var componentClass = current.mgnCtxService.getComponentMapping(component["mgnl:template"]);
            if (typeof componentClass !== "undefined") {
                setTimeout((/**
                 * @return {?}
                 */
                function () {
                    current.loadComponent(componentClass, item, component);
                }));
            }
        }));
    };
    /**
     * Loads the components thanks to its cmsTemplateId
     */
    /**
     * Loads the components thanks to its cmsTemplateId
     * @param {?} componentClassName
     * @param {?} item
     * @param {?} component
     * @return {?}
     */
    AbstractArea.prototype.loadComponent = /**
     * Loads the components thanks to its cmsTemplateId
     * @param {?} componentClassName
     * @param {?} item
     * @param {?} component
     * @return {?}
     */
    function (componentClassName, item, component) {
        /** @type {?} */
        var factories = Array.from(this.resolver['_factories'].keys());
        /** @type {?} */
        var componentClass = factories.find((/**
         * @param {?} x
         * @return {?}
         */
        function (x) {
            return (x.key === componentClassName || x.name === componentClassName);
        }));
        //Gets the component factory
        /** @type {?} */
        var componentFactory = this.resolver.resolveComponentFactory((/** @type {?} */ (componentClass)));
        //Get the view container
        item.viewContainerRef.clear();
        /** @type {?} */
        var componentRef = item.viewContainerRef.createComponent(componentFactory);
        ((/** @type {?} */ (componentRef.instance))).component = component;
    };
    AbstractArea.decorators = [
        { type: Component, args: [{
                    template: ""
                }] }
    ];
    /** @nocollapse */
    AbstractArea.ctorParameters = function () { return [
        { type: ElementRef },
        { type: MagnoliaContextService },
        { type: ComponentFactoryResolver }
    ]; };
    AbstractArea.propDecorators = {
        cmsArea: [{ type: Input }],
        templates: [{ type: ViewChildren, args: [ComponentDirective,] }]
    };
    return AbstractArea;
}());
if (false) {
    /**
     * Area name.
     * @type {?}
     */
    AbstractArea.prototype.cmsArea;
    /**
     * List of area's components.
     * @type {?}
     */
    AbstractArea.prototype.components;
    /**
     * List of the component view containers.
     * @type {?}
     */
    AbstractArea.prototype.templates;
    /**
     * @type {?}
     * @private
     */
    AbstractArea.prototype.elementRef;
    /**
     * @type {?}
     * @private
     */
    AbstractArea.prototype.mgnCtxService;
    /**
     * @type {?}
     * @private
     */
    AbstractArea.prototype.resolver;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var ListArea = /** @class */ (function (_super) {
    __extends(ListArea, _super);
    function ListArea() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    ListArea.decorators = [
        { type: Component, args: [{
                    selector: "[list-area]",
                    template: "<ng-template ngFor let-component [ngForOf]=\"components\">\n    <ng-template [component]=\"component\" cmsComponent></ng-template>\n</ng-template>"
                }] }
    ];
    return ListArea;
}(AbstractArea));

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var AreaDirective = /** @class */ (function () {
    /**
     * Constructor.
     */
    function AreaDirective(el, mgnCtxService) {
        this.el = el;
        this.mgnCtxService = mgnCtxService;
    }
    /**
     * On init
     */
    /**
     * On init
     * @return {?}
     */
    AreaDirective.prototype.ngOnInit = /**
     * On init
     * @return {?}
     */
    function () {
        var _this = this;
        if (this.mgnCtxService.isEditionMode()) {
            //Get the area node
            this.mgnCtxService.getAreaContent(this.cmsArea).then((/**
             * @param {?} areaNode
             * @return {?}
             */
            function (areaNode) {
                //Get the HTML comment
                /** @type {?} */
                var htmlComment = _this.mgnCtxService.getHtmlComment(areaNode["@path"]);
                //Get parent
                /** @type {?} */
                var parentDiv = _this.el.nativeElement.parentNode;
                //Create comment before
                /** @type {?} */
                var commentBefore = document.createComment(htmlComment.start);
                parentDiv.appendChild(commentBefore);
                //Create comment after
                /** @type {?} */
                var commentAfter = document.createComment(htmlComment.end);
                parentDiv.appendChild(commentAfter);
                //Insert comment before
                parentDiv.insertBefore(commentBefore, _this.el.nativeElement);
                //Insert comment after
                parentDiv.insertBefore(commentAfter, _this.el.nativeElement.nextSibling);
            }));
        }
    };
    AreaDirective.decorators = [
        { type: Directive, args: [{
                    selector: '[cmsArea]'
                },] }
    ];
    /** @nocollapse */
    AreaDirective.ctorParameters = function () { return [
        { type: ElementRef },
        { type: MagnoliaContextService }
    ]; };
    AreaDirective.propDecorators = {
        cmsArea: [{ type: Input }]
    };
    return AreaDirective;
}());
if (false) {
    /**
     * Area name.
     * @type {?}
     */
    AreaDirective.prototype.cmsArea;
    /**
     * @type {?}
     * @private
     */
    AreaDirective.prototype.el;
    /**
     * @type {?}
     * @private
     */
    AreaDirective.prototype.mgnCtxService;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var AngularMagnoliaModule = /** @class */ (function () {
    function AngularMagnoliaModule() {
    }
    /**
     * @param {?} environment
     * @return {?}
     */
    AngularMagnoliaModule.forRoot = /**
     * @param {?} environment
     * @return {?}
     */
    function (environment) {
        return {
            ngModule: AngularMagnoliaModule,
            providers: [
                WindowRef,
                {
                    provide: 'env',
                    useValue: environment
                }
            ]
        };
    };
    AngularMagnoliaModule.decorators = [
        { type: NgModule, args: [{
                    imports: [CommonModule, HttpClientModule],
                    declarations: [
                        AreaDirective,
                        ComponentDirective,
                        AbstractArea,
                        ListArea
                    ],
                    providers: [
                        WindowRef
                    ],
                    exports: [
                        AreaDirective,
                        ListArea,
                        ComponentDirective
                    ]
                },] }
    ];
    return AngularMagnoliaModule;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { AbstractArea, AngularMagnoliaModule, AreaDirective, ComponentDirective, ListArea, MagnoliaContextService, WindowRef as ɵa };
//# sourceMappingURL=angular-magnolia.js.map
