import { AfterViewInit, ComponentFactoryResolver, ElementRef, OnInit, QueryList } from '@angular/core';
import { MagnoliaContextService } from '../services/magnolia-context.service';
import { ComponentDirective } from '../directives/component.directive';
export declare class AbstractArea implements OnInit, AfterViewInit {
    private elementRef;
    private mgnCtxService;
    private resolver;
    /** Area name. */
    cmsArea: string;
    /** List of area's components. */
    components: any[];
    /** List of the component view containers. */
    templates: QueryList<ComponentDirective>;
    /**
     * Constructor
     */
    constructor(elementRef: ElementRef, mgnCtxService: MagnoliaContextService, resolver: ComponentFactoryResolver);
    /**
     * On init
     */
    ngOnInit(): void;
    /**
     * Loads component after init
     */
    ngAfterViewInit(): void;
    /**
     * Loads the components dynamically.
     *
     * @param current The current area
     */
    loadComponents(current: AbstractArea): void;
    /**
     * Loads the components thanks to its cmsTemplateId
     */
    loadComponent(componentClassName: string, item: ComponentDirective, component: any): void;
}
